package body Programs is

   package Processes renames Windows.Processes;

   task body Program_Task_Type
   is
      Exit_Code    : Exit_Code_Type;
      Command_Line : access constant String;
      Startup_Informations : Processes.Startup_Informations_Type;
      Startup_Options      : Processes.Startup_Options_Type;
   begin
      select
         accept Run (Command_Line : in String) do
            Program_Task_Type.Command_Line := new String'(Command_Line);
         end;
         Exit_Code :=
           Processes.Run
             (Command_Line         => Command_Line.all,
              Startup_Informations => Startup_Informations,
              Startup_Options      => Startup_Options);
      or
         accept Cancel do
            return;
         end;
      end select;

      select
         accept Get_Exit_Code (Result : out Exit_Code_Type) do
            Result := Exit_Code;
         end;
      or
         accept Cancel do
            return;
         end;
      end select;
   end Program_Task_Type;

   function New_Instance return Instance_Class
   is
   begin
      return Result : Program_Task_Type do
         null;
      end return;
   end;

end Programs;
