with Windows.Processes;

package Programs is

   subtype Exit_Code_Type is Windows.Processes.Exit_Code_Type;

   type Instance_Type is synchronized interface;
   subtype Instance_Class is Instance_Type'Class;

   not overriding procedure Cancel
     (Instance : in out Instance_Type)
   is abstract;

   not overriding procedure Run
     (Instance     : in out Instance_Type;
      Command_Line : in String)
   is abstract;

   not overriding procedure Get_Exit_Code
     (Instance : in out Instance_Type;
      Result   : out Exit_Code_Type)
   is abstract;

   function New_Instance return Instance_Class;

   task type Program_Task_Type is new Instance_Type with
      pragma Storage_Size (4096);
      overriding entry Cancel;
      overriding entry Run (Command_Line : in String);
      overriding entry Get_Exit_Code (Result : out Exit_Code_Type);
   end Program_Task_Type;


end Programs;
