package Windows.Security_Attributes is

   type Instance_Type is private;

   procedure Set_Does_Grant_Access_To_Child_Processes
     (Instance : in out Instance_Type;
      Status   : in Boolean := True);

private

   type Instance_Type is record
      Record_Size_In_Byte : Unsigned_Type :=
        (Instance_Type'Size / Byte_Size);
      Security_Descriptor : Access_Type := Null_Access;
      Does_Grant_Access_To_Child_Processes : Boolean_Type := Boolean_False;
   end record;

   pragma Pack (Instance_Type);
   pragma Convention (Convention => C_Pass_By_Copy, Entity => Instance_Type);
   pragma Assert ((Instance_Type'Size mod Byte_Size) = 0);

   pragma Inline (Set_Does_Grant_Access_To_Child_Processes);

end Windows.Security_Attributes;
