package Windows.Streams is

   Error : exception;

   -- ------------------------------------------------------------------------

   type Input_Type  is limited private;

   type Output_Type is limited private;

   -- ------------------------------------------------------------------------

   No_Input  : constant Input_Type;
   No_Output : constant Output_Type;

private

   type Handle_Type is new Windows.Handle_Type;

   Null_Handle : constant Handle_Type :=
     (Handle_Type (Windows.Null_Handle));

   -- ------------------------------------------------------------------------

   Invalid_Handle : constant Handle_Type :=
     (Handle_Type (Windows.Invalid_Handle));

   -- ------------------------------------------------------------------------

   type Input_Type is record
      Handle : Handle_Type := Null_Handle;
   end record;

   for Input_Type'Size use Handle_Type'Size;
   pragma Convention (Convention => C_Pass_By_Copy, Entity => Input_Type);

   -- ------------------------------------------------------------------------

   type Output_Type is record
      Handle : Handle_Type := Null_Handle;
   end record;

   for Output_Type'Size use Handle_Type'Size;
   pragma Convention (Convention => C_Pass_By_Copy, Entity => Output_Type);

   -- ------------------------------------------------------------------------

   No_Input : constant Input_Type :=
     (Handle => Null_Handle);

   No_Output : constant Output_Type :=
     (Handle => Null_Handle);

end Windows.Streams;
