extern void* instance;
// Defined by the application : exported from Windows.Modules.
// The actual is Current_Module_Reference in the Windows.Modules body.
// Will be initialized by this program entry point.

extern char* commandline;
// Declared by the application : exported from Windows.Strings.
// The actual is Command_Line in the Windows.Strings body.
// Will be initialized by this program entry point.

extern short displaystatus;
// Declared by the application : exported from Windows.Widgets.
// The actual is Initial_Display_Status in the Windows.Widgets body.
// Will be initialized by this program entry point.

void adainit (void);
// Defined by the Ada standard
// Will be invoked by this program entry point.

void adawinmain (void);
// Defined by the application : exported from Windows.Application
// The actual is Run_Application in the Windows.Application body.
// Will be invoked by this program entry point.

void adafinal (void);
// Defined by the Ada standard
// Will be invoked by this program entry point.

int __stdcall WinMain
  (void* hInstance,
   void* hPrevInstance,
   char* lpCmdLine,
   int nCmdShow)
{
  // Pass start up informations to the application.
  // This must be done before adainit is invoked.

   instance      = hInstance;
   commandline   = lpCmdLine;
   displaystatus = (short) (nCmdShow & 0xFFFF);

   adainit ();
  // Initialize the Ada system.
  // This must be done before adawinmain is invoked.

   adawinmain ();
  // Run the application.
  // This is synchronous. Adawinmain will not return until the
  // application terminated.

   adafinal ();
   // Finalize the Ada system

   return 0;
   // This is intended for GUI applications, not for command-line
   // applications, so the return value is always zero.
   // !!! This must return the real exit code.
}
